
timerHW1 equ 20
timerHW2 equ 13
ltimerHW1 equ 60
ltimerHW2 equ 38
rtimerHW1 equ 60
rtimerHW2 equ 38

	include tetmacr.h
	include RomCalls.h
	
	xdef _main
	xdef _nostub
	xdef _ti89

_main:
 movem.l a2-a6/d3-d7,-(sp)
 
;Randomize - seed the random number generator
 moveq.l #0,d0
 move.b $600017,d0
 move.l d0,__randseed
 
 PUSH_LCD_MEM

 moveq.w #6,d0
 trap #9
 lea ($6-$1c)(a0),a0
 move.l a0,kb_vars
 
 move.w  #timerHW1,timer_value
 move.w  #ltimerHW1,ltimer_value
 move.w  #rtimerHW1,rtimer_value

 move.l $c8,a0
 move.l $16b*4(a0),a0;FL_getHardwareParmBloc
 jsr (a0)
 tst.l 6(a0)
 beq     SkipHW2Speed
 move.w  #timerHW2,timer_value
 move.w  #ltimerHW2,ltimer_value
 move.w  #rtimerHW2,rtimer_value
SkipHW2Speed:

 bsr Init
 
 lea statefile(pc),a0
 bsr GetVarHandle	;if there is a state variable, then recover the game
 cmp.w #0,d0
 beq MainRepeat
 move.l $c8,a4

 move.w d0,-(sp)
 FAST_ROM_CALL HeapDeref,a4
 addq.l #2,sp
 
 cmp.w #(StateInfoEnd-StateInfoStart)+(960*2*4)+2+6-2,(a0)+
 bne MainRepeat
;RomCalls.h 
 move.l __D_plane,a1
 move.l  __L_plane,a2
 move.w  #959,d1
\RestoreScreen:
 move.l  (a0)+,(a1)+
 move.l  (a0)+,(a2)+
 dbra	 d1,\RestoreScreen

 move.w #((StateInfoEnd-StateInfoStart)/2)-1,d1
 lea StateInfoStart(pc),a1
\RestoreState
 move.w (a0)+,(a1)+
 dbra d1,\RestoreState
 
 cmp.w #$0074,(a0)+	;0t
 bne MainRepeat
 cmp.l #$6d7000f8,(a0)	;mp0($f8)
 bne MainRepeat
 
 pea statefile(pc)
 FAST_ROM_CALL SymDel,a4
 addq.l #4,sp
 
 add.w	 #40,timer
 st	 intflag
; bra Main
 bra Pause

MainRepeat:
 bsr Titel
 bsr idle_loop
 cmp.w	 #264,d0
 beq Done
 bsr Menu
 cmp.w	 #264,d0
 beq Done
 bsr NewGame
Main:
 tst.w	 twopl
 beq GetKeyInfo
 bsr ReceiveByte
 move.w  d0,d1
 lsr.w	 #4,d0
 beq GetKeyInfo
 and.w	 #$0F,d1
 cmp.w	 #$0F,d0
 beq PenaltyRows
 cmp.w	 #$0E,d0
 beq BarInfoH
 cmp.w	 #$0D,d0
 beq BarInfo
 cmp.w	 #$0C,d0
 bne GetKeyInfo
 lea	 windialog(PC),a6
 bra EndGame
BarInfoH:
 moveq.w #16,d1
BarInfo:
 bsr ShowBar
 bra GetKeyInfo
PenaltyRows:
 bsr RemoveCurPiece
Put_PR:
 bsr TrashRow
 tst.w	 y
 beq NextPR
 subq.w  #1,y
NextPR:
 dbra	 d1,Put_PR
 bsr ShowCurPiece
 bsr SendBarInfo
GetKeyInfo:
 bsr GetKeyStat
 move.w  x(PC),d4
 move.w  y(PC),d5
 move.w  rot(PC),d6
 bsr CheckDown
 bsr CheckLeftRight
 bsr CheckRotate
 bsr CheckDrop

 clr.l	 ltimer
 sf	 upflag
 sf	 downflag
 btst.b  #0,keystat+6
 beq GameOver
 tst.w	 twopl
 bne EndKeyCheck
 btst.b  #7,keystat
 beq Pause
 btst.b  #6,keystat+5
 beq TeacherKey
EndKeyCheck:

CheckTimer:
 tst.w	 timer
 bne Main
ShortWait:
 move.w  timer_value,d0
 move.w  d0,timer
Wait:
 tst.w	 timer
 bne Wait
 bra MoveDown

RetEKC:
 addq.w	 #4,a7
 bra EndKeyCheck

CheckRotate:
 btst.b  #0,keystat
 beq TryRot
SkipUpCheck:
 btst.b  #4,keystat
 beq TryRot
 btst.b  #5,keystat
 bne ClearUp
 addq.w	 #2,d6
TryRot:
 clr.l	 ltimer
 sf	 downflag
 addq.w	 #1,d6
 and.w	 #3,d6
 tst.b	 upflag
 bne RetEKC
 st	 upflag
 lea	 tmpp(PC),a0
 move.w  curPN(PC),d0
 move.w  d6,d1
 bsr Uncrunch
 bsr TestMoveA0
 bne RetEKC
 bsr RemoveCurPiece
 move.w  d6,rot
 bsr UncrunchCurPiece
 bsr ShowCurPiece
 bra RetEKC
ClearUp:
 sf	 upflag
 rts

CheckLeftRight:
 btst.b  #1,keystat
 bne CheckRight
 clr.w	 rtimer
 sf	 downflag
 tst.w	 ltimer
 bne RetEKC
 move.w  ltimer_value,d0
 move.w  d0,ltimer
 subq.w	 #1,d4
 bsr TestMove
 bne RetEKC
 bsr RemoveCurPiece
 move.w  d4,x
 bsr ShowCurPiece
 bra RetEKC
CheckRight:
 clr.w	 ltimer
 btst.b  #3,keystat
 bne ClearRight
 sf	 downflag
 tst.w	 rtimer
 bne RetEKC
 move.w  rtimer_value,d0
 move.w  d0,rtimer
 addq.w	 #1,d4
 bsr TestMove
 bne RetEKC
 bsr RemoveCurPiece
 move.w  d4,x
 bsr ShowCurPiece
 bra RetEKC
ClearRight:
 clr.w	 rtimer
 rts

CheckDown:
 tst.w	 disDflag
 bne Return
 btst.b  #2,keystat
 bne Return
 tst.b	 downflag
 bne RetEKC
 addq.l  #1,score
 addq.w	 #4,a7
 bra ShortWait

CheckDrop:
 btst.b  #6,keystat
 bne ClearDown
TryDrop:
 tst.b	 downflag
 bne RetEKC
Drop:
 addq.w	 #1,d5
 addq.l  #1,score
 bsr TestMove
 beq Drop
 bsr RemoveCurPiece
 move.w  d5,y
 subq.w  #1,y
 bsr ShowCurPiece
 addq.w	 #4,a7
 bra StorePiece
ClearDown:
 sf	 downflag
 rts

MoveDown:
 move.w  levtimer(PC),timer
 move.w  x(PC),d4
 move.w  y(PC),d5
 addq.w	 #1,d5
 bsr TestMove
 bne StorePiece
 bsr RemoveCurPiece
 move.w  d5,y
 bsr ShowCurPiece
 bra Main
StorePiece:
 subq.w	 #1,d5
 moveq.w #3,d7
 lea	 curp(PC),a0
StoreSq:
 move.w  (a0)+,d2
 move.w  (a0)+,d3
 add.w	 d5,d2
 lsl.w	 #4,d2
 add.w	 d3,d2
 add.w	 d4,d2
 st	 0(a5,d2)
 dbra	 d7,StoreSq
 move.l  a5,a0
 lea	 rows(PC),a1
 moveq.w #17,d0
 clr.l	 d2
 clr.l	 d5
CheckRow:
 moveq.w #15,d1
CheckRCol:
 tst.b	 0(a0,d1)
 beq CheckNextRow
 dbra	 d1,CheckRCol
 addq.w	 #1,d5
 move.w  d2,(a1)+
CheckNextRow:
 lea	 16(a0),a0
 addq.w	 #1,d2
 dbra	 d0,CheckRow
 bsr ShowScore
 tst.w	 d5
 beq NewP
 add.w	 d5,lines
 clr.l	 d0
 move.w  lines(PC),d0
 divu.w	 #10,d0
 cmp.w	 level(PC),d0
 blt SameLevel
 move.w  d0,level
 lea	 levels(PC),a0
 lsl.w	 #1,d0
 move.w  0(a0,d0),levtimer
SameLevel:
 subq.w	 #1,d5
 lea	 scoring(PC),a0
 move.w  d5,d0
 lsl.w	 #1,d0
 move.w  0(a0,d0),d0
 move.w  level(PC),d1
 addq.w	 #1,d1
 mulu.w	 d1,d0
 add.l	 d0,score
 moveq.w  #3,d6
Flash:
 move.w  d5,d0
 lea	 rows(PC),a0
 move.l  __D_plane,a1
 move.l  __L_plane,a2
FlashRows:
 move.w  (a0)+,d1
 subq.w	 #2,d1
 mulu.w	 #180,d1
 addq.w	 #1,d1
 moveq.w #5,d2
FlashLine:
 move.w  d1,d3
 move.w	 #9,d4
FlashWord:
 eori.b  #$FF,0(a1,d3.w)
 eori.b  #$FF,0(a2,d3.w)
 addq.w	 #1,d3
 dbra	 d4,FlashWord
 add.w	 #30,d1
 dbra	 d2,FlashLine
 dbra	 d0,FlashRows
 move.w  #40,timer
FlashPause:
 tst.w	 timer
 bne FlashPause
 dbra	 d6,Flash
 move.w  d5,d0
 lea	 rows(PC),a0
MoveLines:
 move.l  __D_plane,a1
 move.l  __L_plane,a2
 move.w  (a0)+,d1
 move.w  d1,d4
 subq.w  #2,d1
 move.w  d1,d3
 mulu.w  #180,d1
 add.w	 #150,d1
 move.w  d1,d2
 sub.w	 #180,d2
 mulu.w  #6,d3
 subq.w  #1,d3
MoveGFXRows:
 move.b  10(a1,d2),10(a1,d1)
 move.b  10(a2,d2),10(a2,d1)
 move.b  1(a1,d2),1(a1,d1)
 move.b  1(a2,d2),1(a2,d1)
 move.b  2(a1,d2),2(a1,d1)
 move.b  2(a2,d2),2(a2,d1)
 move.b  3(a1,d2),3(a1,d1)
 move.b  3(a2,d2),3(a2,d1)
 move.b  4(a1,d2),4(a1,d1)
 move.b  4(a2,d2),4(a2,d1)
 move.b  5(a1,d2),5(a1,d1)
 move.b  5(a2,d2),5(a2,d1)
 move.b  6(a1,d2),6(a1,d1)
 move.b  6(a2,d2),6(a2,d1)
 move.b  7(a1,d2),7(a1,d1)
 move.b  7(a2,d2),7(a2,d1)
 move.b  8(a1,d2),8(a1,d1)
 move.b  8(a2,d2),8(a2,d1)
 move.b  9(a1,d2),9(a1,d1)
 move.b  9(a2,d2),9(a2,d1)
 sub.w	 #30,d1
 sub.w	 #30,d2
 dbra	 d3,MoveGFXRows
 moveq.w #5,d3
ClearTopRows:
 clr.b	 10(a1,d1)
 clr.b	 10(a2,d1)
 clr.b	 1(a1,d1)
 clr.b	 1(a2,d1)
 clr.b	 2(a1,d1)
 clr.b	 2(a2,d1)
 clr.b	 3(a1,d1)
 clr.b	 3(a2,d1)
 clr.b	 4(a1,d1)
 clr.b	 4(a2,d1)
 clr.b	 5(a1,d1)
 clr.b	 5(a2,d1)
 clr.b	 6(a1,d1)
 clr.b	 6(a2,d1)
 clr.b	 7(a1,d1)
 clr.b	 7(a2,d1)
 clr.b	 8(a1,d1)
 clr.b	 8(a2,d1)
 clr.b	 9(a1,d1)
 clr.b	 9(a2,d1)
 sub.w	 #30,d1
 dbra	 d3,ClearTopRows
 move.l  a5,a1
 lsl.w	 #4,d4
 add.w	 d4,a1
 move.l  a1,a2
 lea	 16(a2),a2
 lsr.w	 #2,d4
 subq.w	 #1,d4
UpdateBoard:
 move.l  -(a1),-(a2)
 dbra	 d4,UpdateBoard
 dbra	 d0,MoveLines
 tst.w	 twopl
 beq NewP
 tst.w	 d5
 beq NewP
 move.w  llflag(PC),d0
 lsr.w	 #3,d0
 sub.w	 d0,d5
 move.w  d5,d0
 or.w	 #$F0,d0
 bsr SendByte
NewP:
 tst.w	 twopl
 beq NoBarInfo
 bsr SendBarInfo
NoBarInfo:
 bsr ShowScore
 bsr NewPiece
 moveq.w #6,d4
 clr.l	 d5
 bsr TestMove
 beq Main
GameOver:
 tst.w	 twopl
 beq ShowGameOver
 move.b  #$C0,d0
 bsr SendByte
ShowGameOver:
 lea	 losedialog(PC),a6
EndGame:
 bsr ShowDialog
WaitQRel:
 bsr GetKeyStat
 btst.b	 #0,keystat+6
 beq WaitQRel
 sf	 intflag
; clr.w   (doorsos::kb_vars+$1C)
 CLEAR_KEYPRESS_QUEUE
WaitKeyPress:
 bsr idle_loop
 cmp.w	 #337,d0
 bcs CheckGameOver
 cmp.w	 #353,d0
 bcs WaitKeyPress
CheckGameOver:
 tst.w	 twopl
 bne MainRepeat
 move.l  score(PC),d0
 cmp.l	 hiscore+56,d0
 ble MainRepeat
 lea	 hiscore+16(PC),a0
 moveq.w #2,d1
CheckPl:
 cmp.l	 (a0),d0
 bgt PlFound
 lea	 20(a0),a0
 dbra	 d1,CheckPl
PlFound:
 lea	 hiscore+60(PC),a0
 lea	 hiscore+40(PC),a3
 tst.w	 d1
 beq NoHiMove
 mulu.w	 #5,d1
 subq.w	 #1,d1
MoveHiTable:
 move.l  -(a3),-(a0)
 dbra	 d1,MoveHiTable
NoHiMove:
 move.l  d0,16(a3)

 bsr ClrScr
 SetFont_ #2
 WriteStr_ #16,#20,#4,ent1txt
 SetFont_ #1
 WriteStr_ #5,#38,#4,ent2txt
 WriteStr_ #160/2-(16*6)/2,#50,#4,ent3txt
 bsr CopyScreen
 move.w  #160/2-(15*6)/2,d3
 moveq.w #70,d1
 clr.l	 d4

Input:
 bsr idle_loop
 cmp.w	 #13,d0
 beq InputDone
 cmp.w	 #257,d0
 beq BackSpace
 cmp.w	 #32,d0
 bcs Input
 cmp.w	 #256,d0
 bcc Input
 cmp.w	 #15,d4
 beq Input
 move.b  d0,(a3)+
 move.w  d0,d2
 move.w  d3,d0
 bsr WriteChar
 addq.w	 #6,d3
 addq.w	 #1,d4
 bra Input
BackSpace:
 tst.w	 d4
 beq Input
 clr.b	 -(a3)
 subq.w	 #6,d3
 move.w  d3,d0
 moveq.w #32,d2
 bsr WriteChar
 subq.w	 #1,d4
 bra Input
InputDone:
 clr.b	 (a3)
 bra MainRepeat

ShowScore:
 movem.l d0-d2/a0-a1,-(a7)
 SetFont_ #1
 lea	 tmpstr+6(PC),a0
 move.l  score(PC),d0
 moveq.w  #6,d1
 bsr ConvStr
 WriteStrA_ #106+5,#20-4,#4,a0
 lea	 tmpstr+6(PC),a0
 clr.l	 d0
 move.w  level(PC),d0
 moveq.w #4,d1
 bsr ConvStr
 WriteStrA_ #114+4+5,#40-2,#4,a0
 lea	 tmpstr+6(PC),a0
 clr.l	 d0
 move.w  lines(PC),d0
 moveq.w #4,d1
 bsr ConvStr
 WriteStrA_ #114+4+5,#60,#4,a0
 move.l  __D_plane,a0
 lea     $C(a0),a0
 move.l  __L_plane,a1
 add.w	 #$C,a1
 moveq.w #80,d0
SS_CopyRow:
 moveq.w #8,d1
SS_CopyCol:
 move.b  (a0)+,(a1)+
 dbra	 d1,SS_CopyCol
 lea	 21(a0),a0
 lea	 21(a1),a1
 dbra	 d0,SS_CopyRow
 movem.l (a7)+,d0-d2/a0-a1
 rts

ConvStr:
 movem.l d0-d2,-(a7)
 clr.b	 (a0)
RepConv:
 divu.w	 #10,d0
 move.l  d0,d2
 swap	 d2
 add.b	 #48,d2
 move.b  d2,-(a0)
 subq.w	 #1,d1
 and.l	 #$FFFF,d0
 bne RepConv
 tst.w	 d1
 beq CS_Done
 subq.w	 #1,d1
FillOut:
 move.b  #32,-(a0)
 dbra	 d1,FillOut
CS_Done:
 movem.l (a7)+,d0-d2
 rts


TrashRow:
 movem.l d0-d4/a0-a4,-(a7)
 move.l  __D_plane,a2
 move.l  __L_plane,a3
 moveq.w #1,d1
 move.w  #181,d2
 moveq.w #89,d3
MoveUpGFXRows:
 move.b  0(a2,d2),0(a2,d1)
 move.b  0(a3,d2),0(a3,d1)
 move.b  1(a2,d2),1(a2,d1)
 move.b  1(a3,d2),1(a3,d1)
 move.b  2(a3,d2),2(a3,d1)
 move.b  2(a2,d2),2(a2,d1)
 move.b  3(a3,d2),3(a3,d1)
 move.b  3(a2,d2),3(a2,d1)
 move.b  4(a3,d2),4(a3,d1)
 move.b  4(a2,d2),4(a2,d1)
 move.b  5(a3,d2),5(a3,d1)
 move.b  5(a2,d2),5(a2,d1)
 move.b  6(a3,d2),6(a3,d1)
 move.b  6(a2,d2),6(a2,d1)
 move.b  7(a3,d2),7(a3,d1)
 move.b  7(a2,d2),7(a2,d1)
 move.b  8(a3,d2),8(a3,d1)
 move.b  8(a2,d2),8(a2,d1)
 move.b  9(a3,d2),9(a3,d1)
 move.b  9(a2,d2),9(a2,d1)
 add.w	 #30,d1
 add.w	 #30,d2
 dbra	 d3,MoveUpGFXRows
 add.w	 d1,a2
 add.w	 d1,a3
 move.l  a5,a0
 move.l  a0,a4
 add.w	 #16,a0
 moveq.w #67,d1
MoveUpRows:
 move.l  (a0)+,(a4)+
 dbra	 d1,MoveUpRows
 addq.w	 #3,a4
 moveq.w #9,d3
TR_Fill:
 st	 0(a4,d3)
 dbra	 d3,TR_Fill
 moveq.w #4,d3
MakeHoles:
 moveq.w #10,d0
 bsr internal_random
 clr.b	 0(a4,d0)
 dbra	 d3,MakeHoles
 moveq.w #9,d3
 clr.l	 d2
TR_PutSquares:
 lea     empty(PC),a0
 tst.b	 0(a4,d2)
 beq TR_PutSquare
 lea	 pgfx(PC),a0
 moveq.w #7,d0
 bsr internal_random
 lsl.w	 #4,d0
 add.w	 d0,a0
TR_PutSquare:
 move.l  a2,a1
 bsr PutSprite6
 move.l  a3,a1
 bsr PutSprite6
 addq.w	 #1,d2
 addq.w	 #1,a2
 addq.w	 #1,a3
 dbra	 d3,TR_PutSquares
 movem.l (a7)+,d0-d4/a0-a4
 rts

TestMove:
 lea	 curp(PC),a0
TestMoveA0:
 movem.l d2-d3/d7,-(a7)
 moveq.w #3,d7
CheckSq:
 move.w  (a0)+,d2
 move.w  (a0)+,d3
 add.w	 d5,d2
 lsl.w	 #4,d2
 add.w	 d3,d2
 add.w	 d4,d2
 tst.b	 0(a5,d2)
 bne TM_Done
 dbra	 d7,CheckSq
 cmp.w	 d0,d0
TM_Done:
 movem.l (a7)+,d2-d3/d7
 rts

Pause:
 move.w  timer(PC),d6
 move.l  #2560,-(a7)
 ROM_CALL HeapAlloc
 lea	 4(a7),a7
 move.w  d0,d7
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 addq.l #2,a7
 move.l  a0,a3
 move.l __D_plane,a1
 move.l  __L_plane,a2
 moveq.w   #100,d1
P_MoveRow:
 moveq.w  #5,d2
P_MoveWord:
 move.w  (a1),(a0)+
 clr.w	 (a1)+
 move.w  (a2),(a0)+
 clr.w	 (a2)+
 dbra	 d2,P_MoveWord
 lea	 18(a1),a1
 lea	 18(a2),a2
 dbra	 d1,P_MoveRow
 lea	 pausedialog(PC),a6
 bsr ShowDialog
 SetFont_ #0
 WriteStr_ #48,#55,#4,paus2txt(PC)
 bsr CopyDialogBox
WaitPRel:
 GetKey  #$FFBF,d1
 btst.w  #7,d1
 beq WaitPRel
 sf	 intflag
; clr.w   (doorsos::kb_vars+$1C)
 CLEAR_KEYPRESS_QUEUE
 bsr idle_loop
 clr.w	 -(a7)
 ROM_CALL ST_busy
 addq.w   #2,a7
 st	 intflag
WaitPRelA:
; GetKey  #$FFBF,d1
; btst.w  #7,d1
; beq WaitPRelA
 GetKey 0,d1
 cmp.b #$ff,d1	;let go of the key please
 bne WaitPRelA

 bsr clear_dialog
 bsr CopyDialogBox
 bsr ShowBrickWall
 move.l __D_plane,a1
 move.l  __L_plane,a2
 moveq.w  #100,d1
P_MoveRowB:
 moveq.w  #5,d2
P_MoveWordB:
 move.w  (a3)+,(a1)+
 move.w  (a3)+,(a2)+
 dbra	 d2,P_MoveWordB
 lea	 18(a1),a1
 lea	 18(a2),a2
 dbra	 d1,P_MoveRowB
 move.w  d7,-(a7)
 ROM_CALL HeapFree
 addq.w   #2,a7
 jsr ShowInfoText
 move.w  d6,timer
 bra Main

TeacherKey:
;	trap #4
;	bra EndKeyCheck
 sf intflag
 move.l $c8,a4
 move.l #(StateInfoEnd-StateInfoStart)+(960*2*4)+2+6,-(sp)
 FAST_ROM_CALL HeapAllocHigh,a4
 addq.l #4,sp
 tst.w d0
 beq \NoSaveGame
 
 move.w d0,d3
 lea statefile(pc),a0
 bsr AttachHandleToVar	;create the file, or free the handle if the file can't be created
 cmp.w #0,d3
 beq \NoSaveGame
 
 move.w d3,-(sp)
 FAST_ROM_CALL HeapDeref,a4
 addq.l #2,sp
 move.l __D_plane,a1
 move.l  __L_plane,a2
 move.w #(StateInfoEnd-StateInfoStart)+(960*2*4)+2+6-2,(a0)+	;length of variable
 move.w  #959,d1
\SaveScreen:
 move.l  (a1)+,(a0)+
 move.l  (a2)+,(a0)+
 dbra	 d1,\SaveScreen

 move.w #((StateInfoEnd-StateInfoStart)/2)-1,d1
 lea StateInfoStart(pc),a1
\SaveState
 move.w (a1)+,(a0)+
 dbra d1,\SaveState
 
;variable type == tmp
 move.w #$0074,(a0)+	;0t
 move.l #$6D7000f8,(a0)	;mp0($f8)

\NoSaveGame:
 CLEAR_KEYPRESS_QUEUE
 bra Done

ShowCurPiece:
 movem.l d0-d1/d6/a0,-(a7)
 lea	 curp(PC),a0
 move.w  x(PC),d0
 move.w  y(PC),d1
 move.w  curPN(PC),d6
 bsr ShowPiece
 movem.l (a7)+,d0-d1/d6/a0
 rts

RemoveCurPiece:
 movem.l d0-d1/d6/a0,-(a7)
 lea	 curp(PC),a0
 move.w  x(PC),d0
 move.w  y(PC),d1
 move.w  curPN(PC),d6
 bsr RemovePiece
 movem.l (a7)+,d0-d1/d6/a0
 rts

UncrunchCurPiece:
 movem.l d0-d1/a0,-(a7)
 lea	 curp(PC),a0
 move.w  curPN(PC),d0
 move.w  rot(PC),d1
 bsr Uncrunch
 movem.l (a7)+,d0-d1/a0
 rts

SendBarInfo:
 move.l  a5,a0
 lea	 35(a0),a0
 moveq.w  #16,d0
SBI_CheckRow:
 moveq.w  #9,d1
SBI_CheckCol
 tst.b	 0(a0,d1)
 bne TileFound
 dbra	 d1,SBI_CheckCol
 lea	 16(a0),a0
 dbra	 d0,SBI_CheckRow
TileFound:
 add.w	 #$D0,d0
 bsr SendByte
 rts

ShowBar:
 moveq.w  #15,d2
 move.l __D_plane,a2
 lea $C(a2),a2
 move.l  __L_plane,a3
 add.w  #12,a3
RepShowBar:
 lea	 bargfx(PC),a0
 cmp.w	 d1,d2
 bge EmptyBox
 addq.w  #6,a0
EmptyBox:
 move.l  a0,a4
 move.l  a2,a1
 bsr PutSprite6
 move.l  a4,a0
 move.l  a3,a1
 bsr PutSprite
 lea     180(a2),a2
 lea     180(a3),a3
 dbra	 d2,RepShowBar
 rts

NewPiece:
 lea	 nextp(PC),a0
 moveq.w  #16,d0
 moveq.w  #13,d1
 bsr RemovePiece
 move.w  #6,x
 clr.w	 y
 clr.w	 rot
 move.w  nextPN(PC),curPN
 bsr UncrunchCurPiece
 lea	 curp(PC),a0
 bsr ShowCurPiece
RandomNewPiece:
 moveq.w  #7,d0
 bsr internal_random
 move.w  d0,d6
 move.w  d0,nextPN
 clr.l	 d1
 lea	 nextp(PC),a0
 bsr Uncrunch
 moveq.w  #16,d0
 moveq.w  #13,d1
 bsr ShowPiece
 move.w  levtimer(PC),timer
 add.w	 #20,timer
 st	 downflag
 clr.l	 ltimer
 rts

ShowPiece:
 movem.l d0-d5/a0-a4,-(a7)
 move.l  __D_plane,a1
 move.l  __L_plane,a2
 lea	 pgfx(PC),a3
 move.w  d6,d2
 mulu.w  #12,d2
 adda.w  d2,a3
 cmp.w	 #6,d6
 bne StartPut
 cmp.w	 #3,(a0)
 bne StartPut
 lea     48(a3),a3
StartPut:
 subq.w  #2,d0
 subq.w  #2,d1
 moveq.w  #3,d4
SP_PutSq:
 move.w  d0,d2
 move.w  d1,d3
 add.w	 (a0)+,d3
 add.w	 (a0)+,d2
 btst.w  #15,d3
 bne SP_SkipSq
 mulu.w  #180,d3
 add.w	 d2,d3
 move.l  a3,a4
 moveq.w #5,d5
SP_PutRow:
 move.b  (a4)+,0(a1,d3)
 move.b  5(a4),0(a2,d3)
 add.w	 #30,d3
 dbra	 d5,SP_PutRow
SP_SkipSq:
 cmp.w	 #6,d6
 bne SP_NextSq
 lea     12(a3),a3
SP_NextSq:
 dbra	 d4,SP_PutSq
 movem.l (a7)+,d0-d5/a0-a4
 rts

RemovePiece:
 movem.l d0-d5/a0-a2,-(a7)
 move.l __D_plane,a1
 move.l  __L_plane,a2
 subq.w  #2,d0
 subq.w  #2,d1
 moveq.w  #3,d4
RP_ClrSq:
 move.w  d0,d2
 move.w  d1,d3
 add.w	 (a0)+,d3
 add.w	 (a0)+,d2
 btst.w  #15,d3
 bne RP_SkipSq
 mulu.w  #180,d3
 add.w	 d2,d3
 moveq.w #5,d5
RP_PutRow:
 clr.b	 0(a1,d3)
 clr.b	 0(a2,d3)
 add.w	 #30,d3
 dbra	 d5,RP_PutRow
RP_SkipSq:
 dbra	 d4,RP_ClrSq
 movem.l (a7)+,d0-d5/a0-a2
 rts

Uncrunch:
 movem.l d0-d2/a0-a1,-(a7)
 lea	 pieces(PC),a1
 lsl.w	 #3,d0
 lsl.w	 #1,d1
 add.w	 d1,d0
 move.w  0(a1,d0),d0
 moveq.w  #7,d1
GetBits:
 move.w  d0,d2
 lsr.w	 #2,d0
 and.w	 #$03,d2
 move.w  d2,(a0)+
 dbra	 d1,GetBits
 movem.l (a7)+,d0-d2/a0-a1
 rts

NewGame:
 bsr ClrScr
 moveq.w  #17,d0
 move.l  a5,a1
ClrBoard:
 move.l  #$01010100,(a1)+
 clr.l	 (a1)+
 clr.l	 (a1)+
 move.l  #$00010101,(a1)+
 dbra	 d0,ClrBoard
 moveq.w  #7,d0
BBorder:
 move.w  #$0101,(a1)+
 dbra	 d0,BBorder
 tst.w	 twopl
 beq StartGame
 lea	 waitdialog(PC),a6
 bsr ShowDialog
 SetFont_ #0
 WriteStr_ #38,#54,#4,canctxt(PC)
 bsr CopyScreen
 move.b  #$AA,d0
 bsr SendByte
 
WaitReply:
 CLEAR_KEYPRESS_QUEUE ; clr.w   (doorsos::kb_vars+$1C)
 bsr ReceiveByte
NoByte:
 cmp.b	 #$AA,d0
 beq SynchDone

; cmp.w   #264,(doorsos::kb_vars+$1E)
 TEST_KEY #264
 
 bne WaitReply
 CLEAR_KEYPRESS_QUEUE; clr.w   (doorsos::kb_vars+$1C)
 addq	 #4,a7
 bra MainRepeat
 
SynchDone:
 move.b  #$AA,d0
 bsr SendByte
 bsr ClrScr
 clr.l	 d1
 bsr ShowBar
StartGame:
 st	 intflag
 bsr ShowBrickWall
 move.w  high(PC),d1
 beq NoTrashRows
 lsl.w	 #1,d1
 subq.w  #1,d1
TrashRows:
 bsr TrashRow
 dbra	 d1,TrashRows
NoTrashRows:
 bsr RandomNewPiece
 bsr NewPiece
 clr.l	 score
 clr.w	 lines
 lea	 levels(PC),a0
 move.w  level(PC),d0
 move.w  d0,st_lev
 lsl.w	 #1,d0
 move.w  0(a0,d0),levtimer
ShowInfoText:
 SetFont_ #2
 WriteStr_ #105+2,#10-6,#4,scoretxt(PC)
 WriteStr_ #105+2,#30-4,#4,leveltxt(PC)
 WriteStr_ #105+2,#50-2,#4,linestxt(PC)
 SetFont_ #1
 bsr ShowScore
 rts

WriteChar:
 movem.l d0-d2/a0-a1,-(a7)
 move.w  #$00FF,-(a7)
 clr.w	 -(a7)
 move.w  #$00FF,-(a7)
 move.w  #4,-(a7)
 move.w  d2,-(a7);pull a switcheroo with userlib::DrawCharXY
 move.w  d1,-(a7)
 move.w  d0,-(a7)
; move.w  d2,-(a7); this is where it would be for DrawCharXY

 move.l ($C8),a0
 move.l DrawChar*4(a0),a0
 jsr (a0)
 
 lea	 14(a7),a7
 movem.l (a7)+,d0-d2/a0-a1
 rts


Menu:
 bsr ShowTetrisLogo
 SetFont_ #2
 move.l __D_plane,a0
 lea 46*30+1(a0),a0
 moveq.w  #32,d0
VLines:
 moveq.w  #10,d1
 move.l  a0,a1
VLine:
 move.b  #$80,(a1)
 cmp.b	 #4,d1
SkipVLine:
 addq.w   #2,a1
 dbra	 d1,VLine
 lea	 30(a0),a0
 dbra	 d0,VLines
 move.l __D_plane,a0
 lea 46*30+1(a0),a0
 moveq.w  #2,d0
HLines:
 moveq.w  #17,d1
HLine:
 move.w  d1,d2
 subq.w  #6,d2
 asr.w	 #1,d2
 beq SkipHLine
 st	 (a0)
SkipHLine:
 addq.w   #1,a0
 dbra	 d1,HLine
 lea	 462(a0),a0
 dbra	 d0,HLines
 moveq.w  #12,d0
 moveq.w  #50,d1
 moveq.w  #48,d2
 moveq.w  #9,d3
PutLDig:
 bsr WriteChar
 add.w	 #16,d0
 addq.w   #1,d2
 cmp.w	 #53,d2
 bne LSameRow
 moveq.w  #12,d0
 moveq.w  #66,d1
LSameRow:
 dbra	 d3,PutLDig
 move.w  #108,d0
 moveq.w  #50,d1
 moveq.w  #48,d2
 moveq.w  #5,d3
PutRDig:
 bsr WriteChar
 add.w	 #16,d0
 addq.w   #1,d2
 cmp.w	 #51,d2
 bne RSameRow
 move.w  #108,d0
 moveq.w  #66,d1
RSameRow:
 dbra	 d3,PutRDig
 WriteStr_ #30,#33,#4,leveltxt(PC)
 WriteStr_ #115,#33,#4,hightxt(PC)
 SetFont_  #1
 WriteStr_ #12,#79,#4,tptxt(PC)
 WriteStr_ #12,#91,#4,ltxt(PC)

 move.l   __D_plane,a0
 lea      87*30(a0),a1
 move.l   #$000FE000,(a1)
 lea      99*30+4(a0),a1
 move.w   #$0FE0,(a1)

 bsr CopyScreen
 bsr ShowFlags
 move.w  st_lev(PC),d0
 move.w  d0,d1
 moveq.w  #9,d6
 moveq.w  #5,d5
 bsr Mark
 move.w  high(PC),d0
 moveq.w  #5,d6
 moveq.w  #3,d5
 bsr Mark
 clr.l	 d7
ChooseLevel:
 moveq.w  #5,d5
 moveq.w  #9,d6
ResTimer:
 move.w  #200,timer
WaitKey:
 tst.w	 timer
 bne NoFlash
 move.w  #200,timer
 move.w  d1,d0
 bsr Mark
NoFlash:

; tst.w   (doorsos::kb_vars+$1C)
 IS_KEY_PRESSED
 beq     WaitKey
 move.w  d1,d2

; move.w  (doorsos::kb_vars+$1E),d0
 move.l kb_vars(pc),a0
 lea $1e(a0),a0
 move.w (a0),d0

; clr.w   (doorsos::kb_vars+$1C)
 CLEAR_KEYPRESS_QUEUE
 cmp.w	 #337,d0
 bne CDown
 cmp.w	 d5,d1
 bcs WaitKey
 sub.w	 d5,d1
 bra Update
CDown:
 cmp.w	 #340,d0
 bne CLeft
 cmp.w	 d5,d1
 bcc WaitKey
 add.w	 d5,d1
 bra Update
CLeft:
 cmp.w	 #338,d0
 bne CRight
 tst.w	 d1
 beq WaitKey
 subq.w  #1,d1
 bra Update
CRight:
 cmp.w	 #344,d0
 bne COther
 cmp.w	 d6,d1
 beq WaitKey
 addq.w   #1,d1
Update:
 tst.w	 d7
 bne NoRemove
 move.w  d2,d0
 bsr Mark
NoRemove:
 move.w  d1,d0
 bsr Mark
 clr.l	 d7
 move.w  #200,timer
 bra WaitKey
COther:
 cmp.w	 #264,d0
 beq Return
 cmp.w	 #51,d0
 beq ChangeLLFlag
 cmp.w	 #116,d0
 beq ChangeTPFlag
 cmp.w	 #257,d0
 bne CEnter
 cmp.w	 #9,d6
 beq WaitKey
 tst.w	 d7
 beq ChooseLev
 move.w  d1,d0
 bsr Mark
ChooseLev:
 move.w  d1,high
 move.w  level(PC),d1
 bra ChooseLevel
CEnter:
 cmp.w	 #13,d0
 bne WaitKey
 cmp.w	 #9,d6
 bne HighChosen
 move.w  d1,level
 tst.w	 d7
 beq ChooseHigh
 move.w  d1,d0
 bsr Mark
ChooseHigh:
 moveq.w  #3,d5
 moveq.w  #5,d6
 move.w  high(PC),d1
 bra ResTimer
HighChosen:
 move.w  d1,high
Return:
 rts

ChangeLLFlag:
 eori.w  #8,llflag
 bsr ShowFlags
 bra WaitKey

ChangeTPFlag:
 eori.w  #8,twopl
 bsr ShowFlags
 bra WaitKey

PutSprite:
 moveq.w  #7,d0
PS_PutRow:
 move.b  (a0)+,(a1)
 lea	 30(a1),a1
 dbra	 d0,PS_PutRow
 rts

PutSprite6:
 moveq.w  #5,d0
PS_PutRow6:
 move.b  (a0)+,(a1)
 lea	 30(a1),a1
 dbra	 d0,PS_PutRow6
 addq.w #2,a0
 rts

ShowFlags:
 lea	 box(PC),a0
 add.w	 twopl(PC),a0
 move.l  a0,a2
 move.l  __L_plane,a3
 move.l  __D_plane,a1
 lea     2400(a1),a1
 bsr PutSprite
 add.w	 #2400,a3
 move.l  a3,a1
 move.l  a2,a0
 bsr PutSprite

 lea	 box(PC),a0
 add.w	 llflag(PC),a0
 move.l  a0,a2
 move.l  __L_plane,a3
 move.l  __D_plane,a1
 lea     2730(a1),a1
 bsr PutSprite
 add.w	 #2730,a3
 move.l  a3,a1
 move.l  a2,a0
 bsr PutSprite
 rts

Mark:
 movem.l d0-d1/a0,-(a7)
 bchg	 #0,d7
 move.l  __D_plane,a0
 lea     47*30+1(a0),a0
 cmp.w	 #9,d6
 beq MarkLevel
 lea	 12(a0),a0
MarkLevel:
 cmp.w	 d5,d0
 bcs MarkSquare
 sub.w	 d5,d0
 lea	 480(a0),a0
MarkSquare:
 lsl.w	 #1,d0
 moveq.w  #14,d1
ML_MarkRow:
 eori.b  #$7F,0(a0,d0)
 eori.b  #$FF,1(a0,d0)
 lea	 30(a0),a0
 dbra	 d1,ML_MarkRow
 movem.l (a7)+,d0-d1/a0
 rts

CopyScreen:
 movem.l d0/a0-a1,-(a7)
 move.l  __D_plane,a0
 move.l  __L_plane,a1
 move.w  #959,d0
RepCopy:
 move.l  (a0)+,(a1)+
 dbra	 d0,RepCopy
 movem.l (a7)+,d0/a0-a1
 rts

Titel:
 bsr ShowTetrisLogo
 SetFont_ #2
 WriteStr_ #40,#60,#4,top5txt(PC)
 
 SetFont_ #0
 WriteStr_ #34,#41,#4,author2(PC)
 WriteStr_ #30,#49,#4,author3(PC)
 
 SetFont_ #1
 WriteStr_ #30,#30,#4,author1(PC)
 
 lea	 hiscore(PC),a2
 moveq.w  #5,d0
 moveq.w  #76,d1
 move.l  #$002E0031,d2
 moveq.w  #2,d3
ShowHiscore:
 bsr WriteChar
 swap	 d2
 addq.w   #6,d0
 bsr WriteChar
 swap	 d2
 subq.w  #6,d0
 move.l  d1,d4
 movem.l d0-d2,-(a7)
 WriteStrA_ #23,d1,#4,a2
 lea	 tmpstr+6(PC),a0
 move.l  16(a2),d0
 moveq.w  #6,d1
 bsr ConvStr
 WriteStrA_ #120,d4,#4,a0
 movem.l (a7)+,d0-d2
 lea	 20(a2),a2
 addq.w   #1,d2
 addq.w   #8,d1
 dbra	 d3,ShowHiscore
 bsr CopyScreen
 rts

ShowTetrisLogo:
 bsr ClrScr
 move.l __D_plane,a0
 addq.l  #5,a0
 lea	 logo(PC),a1
 moveq.w  #27,d0
ShowLogo:
 moveq.w  #4,d1
ShowLogoRow:
 move.b  (a1)+,(a0)+
 move.b  (a1)+,(a0)+
 dbra	 d1,ShowLogoRow
 lea	 20(a0),a0
 dbra	 d0,ShowLogo
 rts

ShowDialog:
 bsr show_dialog
CopyDialogBox:
 move.l __D_plane,a0
 lea $1C*30+2(a0),a0
 move.l  __L_plane,a1
 add.w	 #$1C*30+2,a1
 moveq.w  #39,d0
SD_CopyRow:
 moveq.w  #13,d1
SD_CopyByte:
 move.b  (a0)+,(a1)+
 dbra	 d1,SD_CopyByte
 lea	 16(a0),a0
 lea	 16(a1),a1
 dbra	 d0,SD_CopyRow
 rts

ClrScr:
 movem.l d0/a0-a1,-(a7)
 move.l  __D_plane,a0
 move.l  __L_plane,a1
 move.w  #959,d0
RepClr:
 clr.l	 (a0)+
 clr.l	 (a1)+
 dbra	 d0,RepClr
 movem.l (a7)+,d0/a0-a1
 rts

GetKeyStat:
 st intflag
 movem.l d0-d2/a0,-(a7)
 lea	 keystat(PC),a0
 move.w  #$FFFE,d0
 moveq	 #9,d1
GetKeys:
 move.w  d0,$600018
 
 bsr WaitLoop
 
 move.b  $60001B,(a0)+
 
 bsr WaitLoop
 
 rol.w	 #1,d0
 dbra	 d1,GetKeys
 movem.l (a7)+,d0-d2/a0
 sf intflag
 rts

WaitLoop:
 move.w #$25,d2		;loop 25 times (waste time for row reading)
\DoWaitLoop:
 nop
 dbra d2,\DoWaitLoop
 rts

ShowBrickWall:
 move.l __D_plane,a0
 move.l  __L_plane,a1
 moveq.w  #11,d0
PutBrickWall:
 lea	 brickgfx(PC),a2
 moveq.w  #7,d1
PBWRow:
 move.b  (a2),(a0)
 move.b  8(a2),(a1)
 move.b  (a2)+,11(a0)
 move.b  7(a2),11(a1)
 lea	 30(a0),a0
 lea	 30(a1),a1
 dbra	 d1,PBWRow
 dbra	 d0,PutBrickWall
 rts

SendByte:
 movem.l d0-d1/a0-a1,-(a7)
 move.b  d0,linkbuf
 move.w  #1,-(a7)
 pea	 linkbuf(PC)
 ROM_CALL transmit
 addq.w   #6,a7
 movem.l (a7)+,d0-d1/a0-a1
 rts

ReceiveByte:
 movem.l d1/a0-a1,-(a7)
 clr.b	 linkbuf
 move.w  #1,-(a7)
 pea	 linkbuf(PC)
 ROM_CALL receive
 addq.w   #6,a7
 clr.l	 d0
 move.b  linkbuf(PC),d0
 movem.l (a7)+,d1/a0-a1
 rts

Init:
 lea board,a5
 sf	 intflag
 move.l $64,oldint1
 move.l $74,oldint5
 bclr.b #2,$600001
 move.l  #IntHandler,($64)
 move.l #Int5Handler,$74
 bset.b #2,$600001
 bsr GrayOn
 move.l $c8,a4
 FAST_ROM_CALL OSLinkOpen,a4
  
 lea hsfile(pc),a0
 bsr GetVarHandle
 tst.w d0
 beq \nohs
 move.w d0,-(sp)
 FAST_ROM_CALL HeapDeref,a4
 addq.l #2,sp
 
 move.w (a0)+,d1
 subq.w #8,d1
 lea hiscore(pc),a1
\loadhs
 move.b (a0)+,(a1)+
 cmp.l HSTableEnd(pc),a1
 beq \nohs	;don't load anymore that we can handle
 dbra d1,\loadhs
 
\nohs
 rts

Done:
 bsr GrayOff
 bclr.b #2,$600001
 move.l oldint1(PC),($64)
 move.l oldint5(pc),$74
 bset.b #2,$600001
 POP_LCD_MEM

 move.l $c8,a4
 move.w #10,-(sp)
 FAST_ROM_CALL ST_refDsp,a4
 FAST_ROM_CALL ST_eraseHelp,a4
 clr.w (sp)
 FAST_ROM_CALL ST_busy,a4
 addq.l #2,sp
 FAST_ROM_CALL OSLinkClose,a4
 
 move.l #hsvarend-hsvarstart,-(sp)
 FAST_ROM_CALL HeapAlloc,a4
 tst.w d0
 addq.l #4,sp
 beq \verydone
 move.w d0,d3	;for AttachHandleToVar
 move.w d0,-(sp)
 FAST_ROM_CALL HeapDeref,a4
 addq.l #2,sp
 
 move.w #(hsvarend-hsvarstart)-1,d1
 lea hsvarstart(pc),a1
\savehsloop
 move.b (a1)+,(a0)+
 dbra d1,\savehsloop
 
 lea hsfile(pc),a0
 bsr AttachHandleToVar
 
\verydone
 movem.l (sp)+,a2-a6/d3-d7
 rts
  
IntHandler:
 tst.w	 timer
 beq DecLTimer
 subq.w  #1,timer
DecLTimer:
 tst.w	 ltimer
 beq DecRTimer
 subq.w  #1,ltimer
DecRTimer:
 tst.w	 rtimer
 beq CheckFlag
 subq.w  #1,rtimer
CheckFlag:
 tst.b   intflag
 bne EndInt
 move.l  oldint1(PC),-(a7)
 rts
EndInt:
 rte

Int5Handler:
 tst.b intflag
 bne EndInt
 move.l oldint5(pc),-(a7)
 rts
 
	include port.h
	include glib.h
	include files.h

StateInfoStart	;start of data that needs to be saved for the teacher key to work properly

;dialog is for glib.h 	
dialog		dc.w	0	;x
		dc.w	0	;y
		dc.w	0	;width
		dc.w	0	;height
			
oldint1  dc.l 0
oldint5	 dc.l 0

curp	 ds.w 8
nextp	 ds.w 8
tmpp	 ds.w 8
curPN	 dc.w 0
nextPN	 dc.w 0
x	 dc.w 0
y	 dc.w 0
rot	 dc.w 0
rows	 ds.w 4

score	 dc.l 0
lines	 dc.w 0

level	 dc.w 0
high	 dc.w 0

st_lev	 dc.w 0
st_high  dc.w 0
disUflag dc.w 0
disDflag dc.w 0
llflag	 dc.w 0
twopl	 dc.w 0

timer	 dc.w 0
ltimer	 dc.w 0
rtimer	 dc.w 0
levtimer dc.w 0

intflag  dc.b 0
downflag dc.b 0
upflag	 dc.b 0
linkbuf  dc.b 0
tkflag	 dc.b 0

timer_value dc.w 0
ltimer_value dc.w 0
rtimer_value dc.w 0

board ds.b 304

; EVEN	;needs to be word aligned for save code

StateInfoEnd	;end of teacher key state info that needs to be restored

kb_vars dc.l 0
tmpstr	 ds.b 8

levels
 dc.w 310,258,215,179,149,124,104,86,72,60
 dc.w 51,40,36,32,28,24,20,16,13,10,8,6,5,4,3,2,1,0

scoring
 dc.w 40,100,300,1200

pieces
 dc.w %0010011010101011,%0101011000110111
 dc.w %0001001001101010,%0101100101100111
 dc.w %0010011010100011,%0001010101100111
 dc.w %0010011010101001,%0101011001111011
 dc.w %0110101001111011,%0110101001111011
 dc.w %0110101001111011,%0110101001111011
 dc.w %0010011010100111,%0010010101100111
 dc.w %0010010101101010,%0101011001111010
 dc.w %0011011001111010,%0001001001100111
 dc.w %0011011001111010,%0001001001100111
 dc.w %0010011001111011,%0010001101010110
 dc.w %0010011001111011,%0010001101010110
 dc.w %0010011010101110,%0100010101100111
 dc.w %0010011010101110,%0100010101100111

empty
 dc.w 0,0,0,0,0,0,0,0

pgfx
 dc.b %11111111,%10000001,%10111101,%10100101,%10111101,%11111111
 dc.b %11111111,%11111111,%11111111,%11100111,%11111111,%11111111

 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111
 dc.b %11111111,%10000001,%10000001,%10000001,%10000001,%11111111

 dc.b %11111111,%10000001,%10011001,%10011001,%10000001,%11111111
 dc.b %11111111,%10000001,%10011001,%10011001,%10000001,%11111111

 dc.b %11111111,%10000001,%10000001,%10000101,%10111101,%11111111
 dc.b %11111111,%11000011,%11011111,%11011111,%11011111,%11111111

 dc.b %11111111,%11111111,%11111111,%11100111,%11100111,%11111111
 dc.b %11111111,%10000001,%10111101,%10100101,%10111101,%11111111

 dc.b %11111111,%10000001,%10011001,%10011001,%10000001,%11111111
 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111

 dc.b %11111111,%10001001,%00100001,%00000101,%01010001,%11111111
 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111
 dc.b %11111111,%10101000,%00000010,%01000000,%10000100,%11111111
 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111
 dc.b %11111111,%10100000,%00000010,%00100000,%10000100,%11111111
 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111
 dc.b %11111111,%10100100,%10000000,%11001000,%10000000,%11111111
 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111
 dc.b %10000011,%10010001,%11000101,%10010101,%11000011,%11111111
 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111
 dc.b %10010011,%11000001,%10001011,%10100001,%10000011,%11010001
 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111
 dc.b %10010011,%11000001,%10001011,%10100001,%10000001,%10110001
 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111
 dc.b %11111111,%10001001,%10100011,%10000001,%11001001,%10000011
 dc.b %11111111,%11111111,%11111111,%11111111,%11111111,%11111111

box
 dc.b %1111111,%1000001,%1000001,%1000001,%1000001,%1000001,%1111111,0
 dc.b %1111111,%1100011,%1010101,%1001001,%1010101,%1100011,%1111111,0

bargfx
 dc.b $C6,$82,$82,$82,$82,$C6
 dc.b $C6,$82,$BA,$BA,$82,$C6

brickgfx
 dc.b %01000100,%01000100,%01000100,%11111111,%00010001,%00010001,%00010001,%11111111
 dc.b %01011101,%11111111,%11111111,%11111111,%01110111,%11111111,%11111111,%11111111

logo
 dc.b $00,$00,$00,$04,$00,$00,$00,$00,$00,$00
 dc.b $00,$7F,$FF,$F8,$00,$00,$00,$00,$00,$00
 dc.b $03,$FF,$FF,$F0,$00,$00,$00,$00,$00,$00
 dc.b $0F,$FF,$FF,$C0,$00,$00,$00,$06,$00,$00
 dc.b $1F,$C0,$00,$00,$00,$20,$00,$0F,$00,$00
 dc.b $38,$38,$00,$00,$00,$20,$00,$0F,$00,$00
 dc.b $60,$07,$00,$00,$00,$60,$00,$0E,$00,$00
 dc.b $40,$03,$C0,$00,$00,$60,$00,$04,$00,$00
 dc.b $80,$01,$E0,$00,$00,$E0,$00,$00,$00,$00
 dc.b $80,$01,$E0,$01,$E3,$F8,$41,$86,$01,$C8
 dc.b $80,$00,$F0,$07,$F0,$E0,$E3,$CF,$07,$F8
 dc.b $00,$00,$F0,$0C,$F8,$E1,$E7,$D7,$0C,$30
 dc.b $03,$80,$F8,$18,$70,$E2,$ED,$C7,$0E,$10
 dc.b $0C,$60,$78,$18,$60,$E0,$E9,$87,$0F,$00
 dc.b $10,$30,$78,$38,$40,$E0,$F1,$07,$07,$80
 dc.b $20,$18,$78,$38,$80,$E0,$E0,$07,$03,$E0
 dc.b $20,$18,$78,$39,$00,$E0,$E0,$07,$01,$F0
 dc.b $40,$18,$78,$3A,$00,$E0,$E0,$07,$08,$78
 dc.b $40,$18,$78,$3C,$00,$E4,$E0,$07,$08,$38
 dc.b $40,$10,$78,$3E,$10,$E8,$E0,$07,$4C,$18
 dc.b $60,$20,$78,$1F,$E0,$F0,$E0,$07,$8F,$30
 dc.b $60,$00,$70,$0F,$C0,$60,$C0,$03,$07,$E0
 dc.b $70,$00,$F0,$00,$00,$00,$00,$00,$00,$00
 dc.b $30,$00,$E0,$00,$00,$00,$00,$00,$00,$00
 dc.b $38,$01,$C0,$00,$00,$00,$00,$00,$00,$00
 dc.b $1C,$03,$80,$00,$00,$00,$00,$00,$00,$00
 dc.b $0F,$0F,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $03,$FC,$00,$00,$00,$00,$00,$00,$00,$00

losedialog
 dc.l $0010001C,$007F0044,$0013000F,gotxt,0

windialog
 dc.l $0010001C,$007F0044,$001B000F,wintxt,0

waitdialog
 dc.l $0010001C,$007F0044,$001B000C,waittxt,0

pausedialog
 dc.l $0010001C,$007F0044,$0023000C,pausetxt,0

hsvarstart
 dc.w hsvarend-hiscore	;length
hiscore
 dc.b "---------------",0,0,0,0,0
 dc.b "---------------",0,0,0,0,0
 dc.b "---------------",0,0,0,0,0
HSTableEnd
 dc.b 0,"HIGH",0,$f8	;extension tag
hsvarend

keystat  ds.b 10

scoretxt dc.b "SCORE",0
leveltxt dc.b "LEVEL",0
linestxt dc.b "LINES",0
hightxt  dc.b "HIGH",0
pausetxt dc.b "PAUSE",0
paus2txt dc.b "PRESS ANY KEY",0
waittxt  dc.b "WAITING",0
canctxt  dc.b "PRESS ESC TO CANCEL",0
gotxt	 dc.b "GAME OVER",0
wintxt	 dc.b "YOU WIN",0

tptxt	 dc.b "Two player mode (link)",0
ltxt	 dc.b "2P: Send one row less",0

author1	 dc.b "by Jimmy M",$E2,"rdell",0
author2	 dc.b "TI-89 Port by Joel Jordan",0
author3  dc.b "NOSTUB Port By Greg Dietsche",0

top5txt  dc.b "TOP THREE",0
ent1txt  dc.b "CONGRATULATIONS!",0
ent2txt  dc.b "You entered the Top Three list!",0
ent3txt  dc.b "Enter your name:",0

;_comment dc.b "Tetris 1.60 by Jimmy M",$E2,"rdell",0

 end
